#include "DLTestManager.h"
#include "DLTest.h"
#include "DLDocIDBatchTest.h"
#include "DLVersions.h"
#include <iostream>

using namespace std;

/**
 * \brief The main function of the driver application that runs
 * image content recognition on a list of user specified document images
 * Please make sure that the trained model file model.txt is included in
 * the same directory as the command line executable
 */
int main(int argc, char *argv[])
{
	cout << "University of Maryland Image Content Recognizer" << endl;
	cout << "DOCLIB version " << DL_VERSION << endl;
	cout << "Note: Prior to running the command line, please make sure that the trained model file is in the same directory" << endl;

	// add your new test below
	DLTestManager mgr(argc, argv);

	DLDocIDBatchTest docIDDetectTest("Image content classification ...", argc, argv);
	mgr.addTestCase(&docIDDetectTest);
	mgr.go();

	// end of your test case
}