#include "DLLBP.h"

DLLBP::DLLBP()
{
}

DLLBP::~DLLBP()
{
}

vector<int> DLLBP::getHistogram( DLImage im )
{
	int rows, cols;       
	int* img;
	int* result;

	rows = im.dlGetHeight();
	cols = im.dlGetWidth();

	img = new int[rows*cols];
	
	DL_BYTE* tmp = (unsigned char*)im.dlGetImageData();

	for( int i = 0; i < rows*cols; i++)
		img[i] = tmp[i];

	result = new int[256];

	lbp_histogram(img, rows, cols, result, 0);

	for( int i = 0; i < 256; i ++)
		hist.push_back(result[i]);

	delete []result;
	delete []img;

	return hist;
}

vector<double> DLLBP::getNormalizedHistogram( DLImage im )
{
	vector<double> freq;
	vector<int> hist = getHistogram( im );

	double sum = 0;

	for(unsigned int i = 0; i < hist.size(); i++) 
	{
		sum += hist[i];
	}

	for(unsigned int i = 0; i < hist.size(); i++) 
	{
		freq.push_back(double(hist[i]) / sum);
	}

	return freq;
}

bool DLLBP::saveHist( string filename )
{
	FILE* f = fopen( filename.c_str(), "w+" );

	for(unsigned int i = 0; i < hist.size(); i++) 
	{
		char pchElement[100];
		memset( pchElement, 0, 100 );
		sprintf(pchElement, "%d,", hist[i]);
		fwrite( pchElement, 1, strlen(pchElement), f  );
	}

	fclose( f );

	return true;
}
